package com.xynet.marketing.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @author hechunping
 * @date 2025/2/14
 */
@Configuration
@Slf4j
public class WebConfig implements WebMvcConfigurer {
    @Override
    public void addCorsMappings(CorsRegistry registry) {
        log.info("跨域");
        registry.addMapping("/**") // 对所有路径应用CORS配置
                .allowedOrigins("baidu.com") // 允许的源
                .allowedMethods("GET", "POST", "PUT", "DELETE") // 允许的方法
                .allowedHeaders("*") // 允许的头信息，可以使用 "*" 表示允许所有自定义头信息
                .allowCredentials(true) // 是否允许发送Cookie信息，这对于前端携带认证token非常重要
                .maxAge(3600); // 预检请求的缓存时间（秒）
    }
}
