package com.xynet.marketing.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xynet.marketing.service.*;
import com.xynet.marketing.utils.R;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("test")
@AllArgsConstructor
@Slf4j
public class TestController {
    private ProjectService projectService;

    private ProviderService providerService;

    private MercService mercService;

    private ProviderApiConfigService providerApiConfigService;

    private MercProjectService mercProjectService;

    private MercProjectGoodsService mercProjectGoodsService;

    private MercProjectDeviceService mercProjectDeviceService;

    private PromotionService promotionService;

    private MercCouponService mercCouponService;


    @PostMapping("coupon")
    public R coupon(@RequestBody Map<String, Object> param) {
        JMap<String, Object> param1 = new JHashMap<>(param);
        mercCouponService.updateSimple(param1);
        return R.ok();
    }

    @PostMapping("cc")
    public R cc(@RequestBody Map<String, Object> param) {
        JMap<String, Object> param1 = new JHashMap<>(param);
        List<JMap<String, Object>> goods = param1.getList("goodsList");
        mercProjectGoodsService.saveBatchByActId(1, "promotion", goods);
        mercCouponService.updateSimple(param1);
        return R.ok();
    }

    @PostMapping("factory")
    public Object factory(@RequestBody Map<String, Object> param) {
        String aa = param.getOrDefault("type", "promotion_base").toString();
        //FactoryUtils.getService(PromotionFactory.class, aa).test();
        return R.ok();
    }

    @PostMapping("save")
    public Object save(@RequestBody Map<String, Object> param) {
        Integer integer = promotionService.saveOrUpdate(new JHashMap<>(param));
        return R.ok(integer);
    }

    @PostMapping("test")
    public Object test(@RequestBody Map<String, Object> param) {
        JMap<String, Object> param1 = new JHashMap<>(param);
        JMap<String, Object> page = param1.getMap("page");
        return R.ok(page.getInt("current"));
    }

    @PostMapping("aa")
    public R<Map<String, Object>> aa(@RequestBody Map<String, Object> param) {
        JMap<String, Object> param1 = new JHashMap<>(param);
        Map<String, Object> obj = mercCouponService.obj(param1);
        return R.ok(obj);
    }

    @PostMapping("page")
    public R<Page<Map<String, Object>>> page(@RequestBody Map<String, Object> param) {
        JMap<String, Object> param1 = new JHashMap<>(param);
        Page<Map<String, Object>> list = projectService.page(param1);
        return R.ok(list);
    }

}
